import java.awt.Color;
import java.awt.Font;
import java.awt.FontFormatException;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;

/*
 * Created on 2004-11-21
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author micha
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Configure {
    public static String[] iconTable = new String[7];
    public static boolean[] iconEnabled = new boolean[7];
    public static Color[] colorTable = new Color[7];
    public static Color[] overalColorTable = new Color[4];
    public static int[] controlTable = new int[4];
    public static String avatar = null;
    public static boolean avatarEnabled;
    public static Document doc = null;
    
    public static Font myFontQuasiChancery = null;
    public static Font myFontQuasiBook = null;
    public static Font myFontQuasiTime = null;
    
    public Configure() {
        takeData();
        try{
	        InputStream inFont = new FileInputStream("source/fonts/qzcmi.ttf");
	        myFontQuasiChancery = Font.createFont(Font.TRUETYPE_FONT, inFont);
	        myFontQuasiChancery = myFontQuasiChancery.deriveFont(15f);
	    } catch (FileNotFoundException e) {
	        myFontQuasiChancery = new Font(null, Font.PLAIN, 15);
	    } catch (FontFormatException e) {
	        myFontQuasiChancery = new Font(null, Font.PLAIN, 15);
	    }catch (IOException e) {
	        myFontQuasiChancery = new Font(null, Font.PLAIN, 15);
	    }
	    try{
	        InputStream inFont = new FileInputStream("source/fonts/qbkbi.ttf");
	        myFontQuasiBook = Font.createFont(Font.TRUETYPE_FONT, inFont);
	        myFontQuasiBook = myFontQuasiBook.deriveFont(12f);
	    } catch (FileNotFoundException e) {
	        myFontQuasiBook = new Font(null, Font.PLAIN, 15);
	    } catch (FontFormatException e) {
	        myFontQuasiBook = new Font(null, Font.PLAIN, 15);
	    }catch (IOException e) {
	        myFontQuasiBook = new Font(null, Font.PLAIN, 15);
	    }
	    try{
	        InputStream inFont = new FileInputStream("source/fonts/qtmb.ttf");
	        myFontQuasiTime = Font.createFont(Font.TRUETYPE_FONT, inFont);
	        myFontQuasiTime = myFontQuasiTime.deriveFont(13f);
	    } catch (FileNotFoundException e) {
	        myFontQuasiTime = new Font(null, Font.PLAIN, 15);
	    } catch (FontFormatException e) {
	        myFontQuasiTime = new Font(null, Font.PLAIN, 15);
	    }catch (IOException e) {
	        myFontQuasiTime = new Font(null, Font.PLAIN, 15);
	    }
    }
    
    private static void takeData() {
        SAXBuilder saxBuild = new SAXBuilder();
        
        try {
            doc = saxBuild.build(new File("config/config.xml"));

            Element rootEl = doc.getRootElement();
            Element controlEl = rootEl.getChild("control");
            controlTable[0] = Integer.parseInt(controlEl.getChildText("down"));
            controlTable[1] = Integer.parseInt(controlEl.getChildText("left"));
            controlTable[2] = Integer.parseInt(controlEl.getChildText("rotate"));
            controlTable[3] = Integer.parseInt(controlEl.getChildText("right"));
            
            Element colorEl = rootEl.getChild("color");
            Element imageEl = rootEl.getChild("image");
            for(int i = 0; i < 7; i++) {
                colorTable[i] = new Color(Integer.parseInt(colorEl.getChildText("q"+i)));
                
                if(i < 4) 
                    overalColorTable[i] = new Color(Integer.parseInt(colorEl.getChildText("overal"+i)));
                
                iconTable[i] = imageEl.getChildText("q"+i);
                if(imageEl.getChild("q"+i).getAttributeValue("enabled").compareTo("true") == 0)
                    iconEnabled[i] = true;
                else iconEnabled[i] = false;
                if(iconTable[i] == "") iconTable[i] = null;
            };
            
            
            avatar = imageEl.getChildText("avatar");
            if(imageEl.getChild("avatar").getAttributeValue("enabled").compareTo("true") == 0)
                avatarEnabled = true;
            else avatarEnabled = false;
            if(avatar == "") avatar = null;
            
            
        } catch(IOException e) {
            System.out.println(e.getMessage());
        } catch(JDOMException e) {
            System.out.println(e.getMessage());
        }
        
    }
    
    

}
