import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.IOException;
import java.net.UnknownHostException;

import javax.swing.AbstractListModel;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.ListModel;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;
/*
 * Created on 2004-11-21
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * Class extends JFrame class and create frame and all
 * panels for MegTris game
 * 
 * @author Micha Blicharz
 *
 * 
 */
public class ConnectWindow extends JFrame {

	
	private JPanel jOptionsPane = null;
	private JPanel jMainPane = null;
	private Options opt = null;
	private JPanel jGamePanel = null; 
	
	private JPanel jConnectPane = null;
	private JPanel jLoginPane = null;
	private JLabel info = null;
	private JTextField hostTextF = null;
	private JSpinner portSpiner = null;
	private JTextField loginTextF = null;
	private JPasswordField passwordTextF = null;
	private JPasswordField password2TextF = null;

	private JPanel jListPane = null;
	
	private JScrollPane jRoomsPane = null;
	private JList roomsList = null;
	
	private JScrollPane jRoomPane = null;
	private JList roomList = null;
	private String roomName = null;
	
	private JMenuBar jJMenuBar = null;
	private JMenuItem option = null;
	private JMenuItem megtris = null;
	private JMenuItem oneGame = null;
	private JMenuItem endGame = null;
	private JMenuItem connect = null;
	private JMenuItem disconnect = null;
	
	
	/**
	 * This is the default constructor <p>
	 * It construct the frame with the first page and Menu Bar
	 */
	public ConnectWindow() {
		super();
		initialize();
		this.setVisible(true);
	}
	/**
	 * This method initializes this frame and is caling by constructor
	 * 
	 * @return void
	 * 
	 * @author Micha Blicharz
	 */
	private void initialize() {
		this.setJMenuBar(getJJMenuBar());
		this.setResizable(false);
		switch2(getMainPane());
		this.setTitle("MegTris");
		this.addWindowListener(new WindowAdapter() { 
			public void windowClosing(WindowEvent e) {
			    System.exit(0);
//			    Other.myQuitDialog();
			}
		});
		
		KeyAdapter keyAdap = new KeyAdapter() {
            
            public void keyPressed(KeyEvent e) {
                if(Stat.mainPlayerThred == null) return ;
                
                if(e.getKeyCode() == KeyEvent.VK_P) {
                    
                    if(Stat.pause) Stat.pause = false;
                    else Stat.pause = true;
                    // TODO Change pause
                } else if(e.getKeyCode() == Configure.controlTable[1]) {
                	if(MainPlayerGame.state.canLeft()) MainPlayerGame.state.moveLeft();
                } else if(e.getKeyCode() == Configure.controlTable[3]) {
                    if(MainPlayerGame.state.canRight()) MainPlayerGame.state.moveRight();
                } else if(e.getKeyCode() == Configure.controlTable[2]) {
                    if(MainPlayerGame.state.canRotate()) MainPlayerGame.state.rotate();
                } else if(e.getKeyCode() == Configure.controlTable[0]) {
                    while(MainPlayerGame.state.canDown()) {
                        MainPlayerGame.state.moveDown();
                	}
                };
                
            }
            
        };
        
        this.addKeyListener(keyAdap);
		
		
	}
	/**
	 * This method initializes jOptionsPane
	 * witch is the options panel <p>
	 * This method create object of the <code>Options</code> class 
	 * 
	 * @return JPanel - this is the ready options panel to display
	 * 
	 * @author Micha Blicharz
	 */
	private JPanel getOptionPane() {
	    getRootPane().setSize(500,620);
	    if(jOptionsPane == null) {
		    
		    jOptionsPane = new JPanel();
		    jOptionsPane.setSize(500, 600);
		    jOptionsPane.setLayout(null);
			opt = new Options();
			opt.setBounds(0, 0, 490, 550);
			
			JButton ok = new JButton("Ok");
			JButton cancel = new JButton("Cancel");
			ok.setBounds(270, 555, 100, 30);
			cancel.setBounds(375, 555, 100, 30);
			ok.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    if(opt.configUpdate())
                        switch2(getMainPane());
                }
            });
			cancel.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    opt.update();
                    switch2(getMainPane());
                }
            });
						
			jOptionsPane.add(opt);
			jOptionsPane.add(ok);
			jOptionsPane.add(cancel);
			
			
			
		}
	    opt.update();
	    this.setSize(jOptionsPane.getWidth(),jOptionsPane.getHeight()+55);
		return jOptionsPane;
	}
	
	/**
	 * This method initializes JMainPane 
	 * witch is the panel with title icon
	 * 
	 * @return JMainPane - this is the ready main panel (first title page) to display
	 * 
	 * @author Micha Blicharz
	 */
	private JPanel getMainPane() {
	    getRootPane().setSize(500 ,500);
	    if(jMainPane == null ) {
	        jMainPane = new JPanel();
	        jMainPane.setLayout(null);
	        Icon logo = new ImageIcon("source/defaultImage/logo.png");
	        JLabel label = new JLabel();
	        
	        label.setBounds(0, 0, logo.getIconWidth(), logo.getIconHeight());
	        label.setIcon(logo);
	        jMainPane.add(label);
	        jMainPane.setSize(label.getWidth(),label.getHeight());
	        
	    }

	    this.setSize(jMainPane.getWidth(),jMainPane.getHeight()+55);
	    return jMainPane;
	}
	

	
	/**
	 * This method switches content of ConnectWindow
	 * frame to <code>JPanel</code> panel
	 * 
	 * @param panel to switch to it
	 * 
	 * @author Micha Blicharz
	 */
	private void switch2(JPanel panel) {
	    if(this.getContentPane() != panel) {
	        this.setContentPane(panel);
	    };
	}
	
	/**
	 * This metchod initializes jJMenuBar and return it	
	 * 	
	 * @return JMenuBar	
	 * 
	 * @author Micha Blicharz
	 */    
	private JMenuBar getJJMenuBar() {
		if (jJMenuBar == null) {
			
				jJMenuBar = new JMenuBar();
				JMenu menuFile = new JMenu("File");
				JMenu menuGame = new JMenu("Net Game");
				JMenu menuHelp = new JMenu("Help");
				JMenu menuOneGame = new JMenu("One Game");
				JMenu menuOpt = new JMenu("Options");
				
				jJMenuBar.add(menuFile);
								
				megtris = new JMenuItem("First Page");
				megtris.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        switch2(getMainPane());
                    }
                });
				menuFile.add(megtris);
				JMenuItem exit = new JMenuItem("Exit");
				exit.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        Other.myQuitDialog();
                    }
                });
				menuFile.add(exit);
				
				
				
				jJMenuBar.add(menuOpt);
				option = new JMenuItem("Options");
				option.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        
                        switch2(getOptionPane());
                    }
                });
				menuOpt.add(option);
				
				
				jJMenuBar.add(menuGame);
				connect = new JMenuItem("Connect");
				connect.setEnabled(true);
				connect.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        switch2(getConnectPane());
                        
                        connect.setEnabled(false);
                        disconnect.setEnabled(true);
                        oneGame.setEnabled(false);
                        option.setEnabled(false);
                        megtris.setEnabled(false);
                        
                    }
                });
				menuGame.add(connect);
				disconnect = new JMenuItem("Disconnect");
				disconnect.setEnabled(false);
				disconnect.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        if(Stat.writeCon != null) 
                            Stat.writeCon.destroy();
                        if(Stat.readCon != null) 
                            Stat.readCon.destroy();
                        if(Stat.connection != null) 
                            Stat.connection.close();
                        Stat.writeCon = null;
                        Stat.readCon = null;
                        Stat.connection = null;
                        switch2(getMainPane());
                        
                        connect.setEnabled(true);
                        disconnect.setEnabled(false);
                        oneGame.setEnabled(true);
                        option.setEnabled(true);
                        megtris.setEnabled(true);
                        
                    }
                });
				menuGame.add(disconnect);
				
				
				jJMenuBar.add(menuOneGame);
				oneGame = new JMenuItem("One Player Game");
				oneGame.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        oneGame.setEnabled(false);
                        endGame.setEnabled(true);
                        option.setEnabled(false);
                        megtris.setEnabled(false);
                        
                        switch2(getGamePane(1));
                        Game.begin1();
                    }
                });
				menuOneGame.add(oneGame);
				endGame = new JMenuItem("End Game");
				endGame.setEnabled(false);
				endGame.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        // TODO Change end game
                        switch2(getMainPane());
                        GamePanel.clear();
                        endGame.setEnabled(false);
                        oneGame.setEnabled(true);
                        option.setEnabled(true);
                        megtris.setEnabled(true);
                        Stat.mainPlayerThred.destroy();
                    }
                });
				menuOneGame.add(endGame);
				
				jJMenuBar.add(menuHelp);
				
				for(int i = 0; i < jJMenuBar.getComponentCount(); i++) {
				    JMenu a = (JMenu)jJMenuBar.getComponent(i);
				    a.setFont(Configure.myFontQuasiChancery);
				    for(int j = 0; j < a.getItemCount(); j++) {
				        JMenuItem b = a.getItem(j);
				        b.setFont(Configure.myFontQuasiChancery);
				    }
				}
				
				
			
		}
		return jJMenuBar;
	}
	
	/**
	 * Generate the game panel for <code>numPlay</code> players
	 * 
	 * @param numPlay number of players 
	 * @return jGamePanel
	 * 
	 * @author Micha Blicharz
	 */
	private JPanel getGamePane(int numPlay) {
	    getRootPane().setSize(1000,450);
	    jGamePanel = GamePanel.giveGamePanel(numPlay);
	    this.setSize(jGamePanel.getWidth(), jGamePanel.getHeight()+30);
	    Stat.firstPlayerPanel = GamePanel.firstPlayerPanel;
	    Stat.secondPlayerPanel = GamePanel.secondPlayerPanel;
	    Stat.thirdPlayerPanel = GamePanel.thirdPlayerPanel;
	    jGamePanel.setVisible(true);
	    
	    return jGamePanel;
	}
	
	private JPanel getConnectPane() {
	    info = null;
	    getRootPane().setSize(500, 500);
	    if(jConnectPane == null) {
	        jConnectPane = new JPanel();
	        jConnectPane.setLayout(null);
	        jConnectPane.setSize(500,400);
	        
	        JLabel hostLabel = new JLabel("Give the host name");
	        hostLabel.setFont(Configure.myFontQuasiTime);
	        hostLabel.setBounds(50, 100, 150, 20);
	        hostTextF = new JTextField();
	        hostTextF.setFont(Configure.myFontQuasiBook);
	        hostTextF.setBounds(50, 130, 400, 20);
	        
	        JLabel portLabel = new JLabel("Set port");
	        portLabel.setFont(Configure.myFontQuasiTime);
	        portLabel.setBounds(210, 180, 80, 20);
	        portLabel.setHorizontalAlignment(SwingConstants.RIGHT);
	        portSpiner = new JSpinner();
	        portSpiner.setFont(Configure.myFontQuasiBook);
	        portSpiner.setValue(new Integer(12347));
	        portSpiner.setBounds(300, 180, 80, 20);
	        
	        JButton okButton = new JButton("Connect");
	        okButton.setFont(Configure.myFontQuasiTime);
	        okButton.setBounds(300, 300, 100, 30);
	        okButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    info.setText("");
                    try {
                        Stat.connection = new Connection(hostTextF.getText(),((Integer)portSpiner.getValue()).intValue() );
                        
                        int id;
                        id = Stat.connection.sendSetGame("megtris");
                        Reply rep = Stat.connection.waitReply(id);
                    	if(rep == null) {
                    	    info.setText("Server dont answer");
                    	} else if(rep.getStatus() == "failed") {
                    	    info.setText(rep.getWhy());
                    	} else {
                        	switch2(getLoginPane());
                    	}
                    } catch (UnknownHostException ex) {
                        info.setText(ex.getMessage());
                    } catch (IOException ex) {
                        info.setText(ex.getMessage());
                    }
                }
            });
	        
	        jConnectPane.add(hostLabel);
	        jConnectPane.add(hostTextF);
	        jConnectPane.add(portLabel);
	        jConnectPane.add(portSpiner);
	        jConnectPane.add(okButton);
	        
	        
	        
	    }
	    info = new JLabel();
        info.setBounds(100, 350, 200, 20);
        jConnectPane.add(info);
        
	    this.setSize(jConnectPane.getWidth(),jConnectPane.getHeight()+55);
	    return jConnectPane;
	}
	
	private JPanel getLoginPane() {
	    info = null;
        
	    if(true/*jLoginPane == null*/) {
	        jLoginPane = new JPanel();
	        jLoginPane.setLayout(null);
	        jLoginPane.setSize(500, 400);
	        
	        JLabel loginLabel = new JLabel("Login");
	        loginLabel.setBounds(100, 60, 150, 20);
	        loginTextF = new JTextField();
	        loginTextF.setBounds(100, 85, 150, 20);
	        
	        JLabel passLabel = new JLabel("Password");
	        passLabel.setBounds(100, 130, 150, 20);
	        passwordTextF = new JPasswordField();
	        passwordTextF.setBounds(100, 155, 150, 20);
	        
	        JLabel pass2Label = new JLabel("Repeat Password (Only when creating new account)");
	        pass2Label.setBounds(100, 200, 350, 20);
	        password2TextF = new JPasswordField();
	        password2TextF.setBounds(100, 225, 150, 20);
	        
	        JButton okButton = new JButton("Login");
	        okButton.setBounds(300, 300, 100, 30);
	        okButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    int id;
                    id = Stat.connection.sendLogin(loginTextF.getText(), 
                            String.valueOf(passwordTextF.getPassword()));
                    Reply rep = Stat.connection.waitReply(id);
                    
                    if(rep == null) {
                        info.setText("Server dont answer");
                        passwordTextF.setText("");
                        password2TextF.setText("");
                    } else if(rep.getStatus() == "failed") {
                        info.setText(rep.getWhy());
                        passwordTextF.setText("");
                        password2TextF.setText("");
                    } else {
                        switch2(getListPane(null));
                    }
                }
            });
	        
	        
	        
	        JButton create = new JButton("Create new account");
	        create.setBounds(50, 300, 170, 30);
	        create.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    int id;
                    id = Stat.connection.sendRegister(loginTextF.getText(), 
                            String.valueOf(passwordTextF.getPassword()), 
                            String.valueOf(password2TextF.getPassword()));
                    Reply rep = Stat.connection.waitReply(id);
                    
                    if(rep == null) {
                        info.setText("Server dont answer");
                        passwordTextF.setText("");
                        password2TextF.setText("");
                    } else if(rep.getStatus() == "failed") {
                        info.setText(rep.getWhy());
                        passwordTextF.setText("");
                        password2TextF.setText("");
                    } else {
                        switch2(getListPane(null));
                    }
                }
            });
	        
	        jLoginPane.add(loginLabel);
	        jLoginPane.add(loginTextF);
	        jLoginPane.add(passLabel);
	        jLoginPane.add(pass2Label);
	        jLoginPane.add(passwordTextF);
	        jLoginPane.add(password2TextF);
	        jLoginPane.add(okButton);
	        jLoginPane.add(create);
	        
	        
	        
	        for(int i = 0; i < jLoginPane.getComponentCount(); i++) {
	            if(jLoginPane.getComponent(i).getClass() == JLabel.class) {
	                jLoginPane.getComponent(i).setFont(Configure.myFontQuasiTime);
	            } else if(jLoginPane.getComponent(i).getClass() == JButton.class) {
	                jLoginPane.getComponent(i).setFont(Configure.myFontQuasiTime);
	            } else {
	                jLoginPane.getComponent(i).setFont(Configure.myFontQuasiBook);
	            }
	        }
	    }
	    
	    info = new JLabel();
        info.setBounds(100, 350, 200, 20);
        jLoginPane.add(info);
        
	    this.setSize(jLoginPane.getWidth(),jLoginPane.getHeight()+55);
	    return jLoginPane;
	}
	
	private JPanel getListPane(String roomN) {
	    getRootPane().setSize(550, 550);
	    jListPane = null;
	    
	    if(true/*jListPane == null*/) {
	        
	        jListPane = new JPanel();
	        jListPane.setLayout(null);
	        jListPane.setSize(500, 400);
	        
	        
	        JList playerList = new JList();
	        int id;
	        id = Stat.connection.sendGetPlayersInGame();
	        Reply rep = Stat.connection.waitReply(id);
	        
	        if(rep == null) {
	            System.out.println("Server dont answer"); //TODO change
	        } else if(rep.getStatus() == "failed") {
	            System.out.println(rep.getWhy()); // TODO change
	        } else {
	            playerList.setListData(rep.getPlayers());
	        }
	        
	        playerList.setBounds(0, 0, 0, 0);
	        playerList.enableInputMethods(false);
	        playerList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	        playerList.setFont(Configure.myFontQuasiBook);
	        
	        JScrollPane playerPanel = new JScrollPane(playerList);
	        playerPanel.setBounds(350, 50, 140, 350);
	        JLabel playersLabel = new JLabel("Players");
	        playersLabel.setBounds(350, 25, 140, 20);
	        
	        jListPane.add(playersLabel);
	        jListPane.add(playerPanel);
	        
	        if(roomN == null) {
	            JLabel roomsLabel = new JLabel("Rooms");
	            roomsLabel.setBounds(20, 25, 100, 20);
	            
	            JScrollPane roomPanel = getRoomsPane();
	            roomPanel.setBounds(20, 50, 320, 310);
	            
	            JButton goInto = new JButton("Go into");
	            goInto.setBounds(210, 370, 130, 30);
	            goInto.addActionListener(new ActionListener() {
	                public void actionPerformed(ActionEvent e) {
	                    int id;
	                    Room r = (Room)roomsList.getSelectedValue();
	                    if(r == null) {
	                        System.out.println("You have to select room");
	                        return ;
	                    }
	                    roomName = r.getName();
	                    id = Stat.connection.sendJoinRoom(roomName);
	                    Reply rep = Stat.connection.waitReply(id);
	                    if(rep == null) {
	                        System.out.println("Server dont answer"); //TODO change
	                    } else if(rep.getStatus() == "failed") {
	                        System.out.println(rep.getWhy()); // TODO change
	                    } else {
	                        switch2(getListPane(roomName));
	                        
	                    }
	                }
	            });
	        
	        
	            JButton createNew = new JButton("Create new room");
	            createNew.setBounds(20, 370, 180, 30);
	            createNew.addActionListener(new ActionListener() {
	                public void actionPerformed(ActionEvent e) {
	                    //TODO new Room
	                }
	            });
	            
	            jListPane.add(roomsLabel);
	            jListPane.add(roomPanel);
	            jListPane.add(goInto);
	            jListPane.add(createNew);
	        } else {
	            JLabel roomLabel = new JLabel(roomName);
	            roomLabel.setBounds(20, 25, 100, 20);
	            
	            JScrollPane roomPanel = getRoomPane(roomName);
	            roomPanel.setBounds(20, 50, 320, 310);
	            
	            JButton leave = new JButton("Leave");
	            leave.setBounds(210, 370, 130, 30);
	            leave.addActionListener(new ActionListener() {
	                public void actionPerformed(ActionEvent e) {
	                    roomName = null;
	                    int id;
	                    id = Stat.connection.sendLeaveRoom();
	                    
	                    Reply rep = Stat.connection.waitReply(id);
	                    if(rep == null) {
	                        System.out.println("Server dont answer"); //TODO change
	                    } else if(rep.getStatus() == "failed") {
	                        System.out.println(rep.getWhy()); // TODO change
	                    } else {
	                        switch2(getListPane(null));
	                        
	                    }
	                }
	            });
	        
	        
	            JButton startGame = new JButton("Start Game");
	            startGame.setBounds(20, 370, 180, 30);
	            startGame.addActionListener(new ActionListener() {
	                public void actionPerformed(ActionEvent e) {
	                    //TODO start Game
	                }
	            });
	            
	            jListPane.add(roomLabel);
	            jListPane.add(roomPanel);
	            jListPane.add(leave);
	            jListPane.add(startGame);
	            
	        }
	            
	        
	        
	        
	        for(int i = 0; i < jListPane.getComponentCount(); i++) {
	            if(jListPane.getComponent(i).getClass() == JLabel.class) {
	                jListPane.getComponent(i).setFont(Configure.myFontQuasiTime);
	            } else if(jLoginPane.getComponent(i).getClass() == JButton.class) {
	                jListPane.getComponent(i).setFont(Configure.myFontQuasiTime);
	            } else {
	                jListPane.getComponent(i).setFont(Configure.myFontQuasiBook);
	            }
	        }
	    }
	    
	    this.setSize(jListPane.getWidth()+5,jListPane.getHeight()+55);
	    return jListPane;
	}
	
	private JScrollPane getRoomsPane() {
	    if(jRoomsPane == null) {
	        
	        ListModel model = new AbstractListModel() {
                public int getSize() {
                    return 0;
                }
                public Object getElementAt(int index) {
                    return null;
                }
            };
            
	        int id;
	        id = Stat.connection.sendGetRooms();
	        final Reply rep = Stat.connection.waitReply(0/*id*/);
	        if(rep == null) {
	            System.out.println("Server dont answer"); //TODO change
	        } else if(rep.getStatus() == "failed") {
	            System.out.println(rep.getWhy()); // TODO change
	        } else {
	            
	            model = new AbstractListModel() {
                	public int getSize() {
                    	return rep.getRomms().size();
                	}
                	public Object getElementAt(int index) {
                    	return rep.getRomms().elementAt(index);
                	}
            	};
	        }
	        
	        roomsList = new JList(model);
	        roomsList.setFont(Configure.myFontQuasiBook);
	        roomsList.enableInputMethods(false);
	        roomsList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	        
	        
	        
	        jRoomsPane = new JScrollPane(roomsList);
	    }
	    
	    
	    return jRoomsPane;
	}
	
	private JScrollPane getRoomPane(String roomName) {
	    
	    ListModel model = new AbstractListModel() {
            public int getSize() {
                return 0;
            }
            public Object getElementAt(int index) {
                return null;
            }
        };
        
        int id;
        id = Stat.connection.sendGetPlayersInRoom(roomName);
        final Reply rep = Stat.connection.waitReply(0/*id*/);
        if(rep == null) {
            System.out.println("Server dont answer "); //TODO change
        } else if(rep.getStatus() == "failed") {
            System.out.println(rep.getWhy()); // TODO change
        } else {
            
            model = new AbstractListModel() {
            	public int getSize() {
                	return rep.getPlayers().size();
            	}
            	public Object getElementAt(int index) {
                	return rep.getPlayers().elementAt(index);
            	}
        	};
        }
        
        roomList = new JList(model);
        Configure.myFontQuasiBook.deriveFont(20f);
        roomList.setFont(Configure.myFontQuasiBook.deriveFont(20f));
        roomList.enableInputMethods(false);
        roomList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        
        
        
        jRoomPane = new JScrollPane(roomList);
	    
	    
	    return jRoomPane;
	}
	
	
	
	public void roomUpdate() {
	    switch2(getListPane(roomName));
	}
	

	
	
 }  //  @jve:decl-index=0:visual-constraint="447,14"

