import java.io.IOException;
import java.io.DataInputStream;
import java.io.StringBufferInputStream;
import java.io.InputStream;
import java.util.Iterator;
import java.util.List;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;

/*
 * Created on 2004-11-28
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author micha
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ReadConnection extends Thread {
    private DataInputStream input = null;
    private SAXBuilder saxBuild = null;
    
    private boolean destroy = false;
    
    public ReadConnection(DataInputStream in) {
        input = in;
        saxBuild = new SAXBuilder();
    }
    
    public void run() {
        String reply = null;
        byte[] rep = new byte[1000];
        int num = 0;
        
        
        while(!destroy) {
            try{
                reply = input.readUTF();
                
                parse(reply);
                
                
                System.out.println(reply);
                reply = null;
                
                
            } catch(IOException e) {
                System.out.println(e.getMessage());
            }
            
        }
    }
    
    private void parse(String str) {
        InputStream inStr = new StringBufferInputStream(str);
        Document doc;
        
        try {
            doc = saxBuild.build(inStr);
            Element rootEl = doc.getRootElement();
            
            if(rootEl.getName().compareTo("reply") == 0) {
                reply(doc);
            } else if(rootEl.getName().compareTo("broadcastInRoom") == 0) {
                broadcastInRoom(doc);
            } else if(rootEl.getName().compareTo("broadcastInGame") == 0) {
                broadcastInGame(doc);
            } else {
                System.out.println("I don't know the name of info");
            }
            
            
            
        } catch (JDOMException e) {
            System.out.println(e.getMessage());
        } catch (IOException e) {
            System.out.println(e.getMessage());
        }
        
        
        
    }
    
    /**
     * This method interpret the XML <code>Document</code> if his 
     * root <code>Element</code> is "reply" and put the <code>Reply</code> 
     * class object on <code>Stat.idTable</code>
     * 
     * @param doc XML <code>Document</code> to parse
     * 
     * @author Micha Blicharz
     */
    private void reply(Document doc) {
        int id;
        Reply reply = null;
        
        Element rootEl = doc.getRootElement();
        String type = rootEl.getAttributeValue("type");
        
        id = Integer.parseInt(rootEl.getAttributeValue("id"));
        
        if(rootEl.getChild("failed") != null) {
            reply = new Reply("failed",rootEl.getChild("failed").getAttributeValue("reason"));
            
        } else if( (type.compareTo("setGame") == 0) ||
                (type.compareTo("login") == 0) ||
                (type.compareTo("logout") == 0) ||
                (type.compareTo("register") == 0) ||
                (type.compareTo("joinRoom") == 0) ||
                (type.compareTo("leaveRoom") == 0) ) {
            reply = new Reply();
        } else if( type.compareTo("getRooms") == 0 ) {
            List roomList = rootEl.getChildren("room");
            reply = new Reply();
            
            Iterator it;
            for(it = roomList.iterator(); it.hasNext(); ) {
                Element roomEl = (Element)it.next();
                reply.addRoom(new Room(roomEl.getChildText("name"), Integer.parseInt(roomEl.getAttributeValue("players")) ) );
            }
            
        } else if( type.compareTo("getPlayersInGame") == 0 ) {
            List playerList = rootEl.getChildren("player");
            reply = new Reply();
            
            Iterator it;
            for(it = playerList.iterator(); it.hasNext(); ) {
                Element playerEl = (Element)it.next();
                reply.addPlayer(playerEl.getText());
            }
            
        } else if( type.compareTo("getPlayersInRoom") == 0 ) {
            List playerList = rootEl.getChildren("player");
            reply = new Reply();
            
            Iterator it;
            for(it = playerList.iterator(); it.hasNext(); ) {
                Element playerEl = (Element)it.next();
                reply.addPlayer(playerEl.getText());
            }
            
        }
        
        
        
        
        //TODO other types
        
        
        Stat.idTable.put(new Integer(id), reply);
    }
    
    private void broadcastInRoom(Document doc) {
        Reply reply = null;
        
        Element rootEl = doc.getRootElement();
        String type = rootEl.getAttributeValue("type");
        
        if(type.compareTo("joinRoom") == 0) {
            String playerLogin = rootEl.getChildText("name");
            reply = new Reply(playerLogin);
            
            Stat.frame.roomUpdate();
            
        }
        
        
        //TODO broadcastInRoom
    }
    
    private void broadcastInGame(Document doc) {
        
        //TODO broadcastInGame
    }
 
    
    public void destroy() {
        destroy = true;
    }
}
